RecursiveCachingIterator::hasChildren
RecursiveCallbackFilterIterator::__construct
Iterators
PHP Manual

# The RecursiveCallbackFilterIterator class

(PHP 5 >= 5.4.0)

## Introduction

## Class synopsis

RecursiveCallbackFilterIterator extends CallbackFilterIterator implements OuterIterator , RecursiveIterator {
/* Methods */
public __construct ( RecursiveIterator `$iterator` , string `$callback` )
public RecursiveCallbackFilterIterator getChildren ( void )
public void hasChildren ( void )
/* Inherited methods */
public string CallbackFilterIterator::accept ( void )
}

## Examples

The callback should accept up to three arguments: the current item, the current key and the iterator, respectively.

Example #1 Available callback arguments

`<?php
/**
* Callback for RecursiveCallbackFilterIterator
*
* @param $current Current item's value
* @param $key Current item's key
* @param $iterator Iterator being filtered
* @return boolean TRUE to accept the current item, FALSE otherwise
*/
function my_callback($current, $key, $iterator) {
// Your filtering code here
}
?>`

Filtering a recursive iterator generally involves two conditions. The first is that, to allow recursion, the callback function should return `TRUE` if the current iterator item has children. The second is the normal filter condition, such as a file size or extension check as in the example below.

Example #2 Recursive callback basic example

`<?php
$dir = new RecursiveDirectoryIterator(__DIR__);
// Filter large files ( > 100MB)
$files = new RecursiveCallbackFilterIterator($dir, function ($current, $key, $iterator) {
// Allow recursion
if ($iterator->hasChildren()) {
return TRUE;
}
// Check for large file
if ($current->isFile() && $current->getSize() > 104857600) {
return TRUE;
}
return FALSE;
});
foreach (new RecursiveIteratorIterator($files) as $file) {
echo $file->getPathname() . PHP_EOL;
}
?>`

## Table of Contents

- RecursiveCallbackFilterIterator::__construct — Create a RecursiveCallbackFilterIterator from a RecursiveIterator
- RecursiveCallbackFilterIterator::getChildren — Return the inner iterator's children contained in a RecursiveCallbackFilterIterator
- RecursiveCallbackFilterIterator::hasChildren — Check whether the inner iterator's current element has children

RecursiveCachingIterator::hasChildren
RecursiveCallbackFilterIterator::__construct
Iterators
PHP Manual